# 提供天气实况服务的模拟服务器
# 需安装flask: pip install flask
# 需把本单元格内容用 %%writefile tq.py 命令保存至tianqi.py，并在终端用python tq.py来运行，出现以下提示：
# WARNING: This is a development server. Do not use it in a production deployment. Use a production WSGI server instead.
# * Running on all addresses (0.0.0.0)
# * Running on http://127.0.0.1:5000
#  * Running on http://192.168.1.104:5000
# Press CTRL+C to quit
# 表明服务器正常，把 http://192.168.1.104:5000 网址提供给学生即可。

from flask import Flask
import requests
import os
import time
import pickle
import json


def getWeather():
    '''天气数据api，返回json文本数据'''
    if os.path.exists('tianqi.bin'):
        print('正在从tianqi.bin中读取变量...')
        with open('tianqi.bin', 'rb') as f:
            txt = pickle.load(f) #读取变量值
            dic = json.loads(txt)
            address = dic["fxLink"]
            update = dic["updateTime"]
            a = list(map(int,update.split('T')[0].split('-')))
            b = [time.localtime().tm_year,time.localtime().tm_mon,time.localtime().tm_mday]
            if a==b:
                print('利用已存在数据{}.'.format(a))
                return txt
    print('将tianqi.bin数据更新到{}.'.format([time.localtime().tm_year,time.localtime().tm_mon,time.localtime().tm_mday]))
    key = '4eba8e5f50f04858ba132c2c7c06edda' # 只是演示的免费订阅key，务必替换为您自己的和风天的key, 注册地址：https://id.qweather.com/#/login
    loc = '101150101' # 设置地区码(此处为西宁)，可以到网页https://www.qweather.com/weather/xining-101150101.html查找，
                      #.html前的这串数字。https://www.qweather.com/weather/xining-101150101.html
    url = 'https://devapi.qweather.com/v7/weather/now?location={}&key={}'.format(loc, key)  # 这里采用和风天气免费订阅
    #提供动态内容，否则注释之
    txt = requests.get(url).content.decode()
    # 如果以上三行程序不能正常运行，请采用下面固定的格式来提供
    # 若提供固定内容，则修改下面的内容，且下行txt去掉注释（默认)，此处数据格式是从和风实时天气服务api（感谢和风天气的免费订阅服务）
    #txt=\
    '''{
    "code":"200",
    "updateTime":"2023-08-19T21:22+08:00",
    "fxLink":"https://www.qweather.com/weather/xining-101150101.html",
    "now":{
        "obsTime":"2023-08-19T21:14+08:00",
        "temp":"16",
        "feelsLike":"14",
        "icon":"150",
        "text":"晴",
        "wind360":"135",
        "windDir":"东南风",
        "windScale":"2",
        "windSpeed":"7",
        "humidity":"48",
        "precip":"0.0",
        "pressure":"762",
        "vis":"30",
        "cloud":"10",
        "dew":"10"
    },
    "refer":{
        "sources":[
            "QWeather",
            "NMC",
            "ECMWF"
        ],
        "license":[
            "CC BY-SA 4.0"
        ]
    }
}'''
    with open('tianqi.bin', 'wb') as f:
        pickle.dump(txt, f) #把a存入文件中
    return txt


app = Flask(__name__)
app.debug = True
@app.route('/')
def hello_world():
    return getWeather()

if __name__ == '__main__':
    app.run(host='0.0.0.0',port=5000)
