# 参考程序 - 受邀人员管理程序升级版 - 增加邀请函生成功能
import tkinter as tk
import os
import random
from PIL import Image,ImageTk, ImageDraw, ImageFont
def mySelect(event):
    '''响应列表选择事件'''
    index = lbx.curselection()  # 获取所选项的索引放入index序列变量中
    if index:
        index = index[0]  # 取首项（单选只需取一项）
        txt.delete(0,'end')  # 输入框清空
        txt.insert(0,lbx.get(index))  # 把所选项的姓名插入输入框中
        # 照片显示，需要PIL库支持，可用 pip install pillow 安装
        imgFile = '{}.png'.format(lbx.get(index))
        if not os.path.exists(imgFile):
            imgFile = random.choice(['photo1.png','photo2.png'])
        Img = Image.open(imgFile).resize((144,172))
        img = ImageTk.PhotoImage(Img)
        lblImg.img = img
        lblImg['image'] = img


def myDelete():
    '''响应删除按钮'''
    index = lbx.curselection()
    if index:
        index = index[0]
        lbx.delete(index)  # 删除列表框中的所选项
        updateFile()


def myUpdate():
    '''响应修改按钮'''
    index = lbx.curselection()
    if index:
        index = index[0]
        lbx.delete(index)  # 删除列表框中的所选项
        lbx.insert(index, txt.get())  # 把更新后内容插入到列表框所选位置
        updateFile()


def myAdd():
    '''响应增加按钮'''
    item = txt.get()  # 获取输入框的内容
    if item:
        lbx.insert('end', item)  # 在列表框末位增加内容
        updateFile()

def updateFile():
    with open('people.txt', 'w', encoding='UTF-8') as f:
        names = lbx.get(0, 'end')
        for name in names:
            print(name,file=f)
    win.title('受邀人员管理程序-已保存')

        
def onePic(name):
    '''该函数产生一张图片'''
    # 打开th.png图片作为模板图片
    img = Image.open('th.png')
    # 建立绘图实例
    draw = ImageDraw.Draw(img)
    # 指定简黑体字体，字体大小为36号
    myFont = ImageFont.truetype('SourceHanSansCN-Bold.otf', 36)
    # 在图片中(40,80)位置，以黑色的黑体字填上"张三"
    draw.text((160, 210), name, fill=(0, 0, 0), font=myFont)
    draw.text((800, 490), 'XXXX学校', fill=(0, 0, 0), font=myFont)
    draw.text((800, 572), 'X年X月X日', fill=(0, 0, 0), font=myFont)
    # 以'张三的邀请函.png'为文件名保存
    img.save('{}的邀请函.png'.format(name))
    print('生成了图片 {}的邀请函.png'.format(name))
    img.close()
def genPics():
    btn4['text'] = '正在生成邀请函...'
    lst = list(lbx.get(0, 'end'))
    for file in lst:
        onePic(file)
    btn4['text'] = '邀请函生成完毕！'
        
# 建立窗口
win = tk.Tk()
win.title('受邀人员管理程序')
win.geometry('420x320')
# 定义组件
lbl = tk.Label(win, text='选择一行【删除】或在文本框中修改后按【修改】或【增加】')
lbx = tk.Listbox(win)
# 验证本地文件
if not os.path.exists('people.txt'):
    with open('people.txt', 'w', encoding='UTF-8') as f:
        f.write('张三\n李四')
with open('people.txt', 'r', encoding='UTF-8') as f:
    names = f.readlines()
    for name in names:
        lbx.insert('end', name.strip())
txt = tk.Entry(win)
btn1 = tk.Button(win, text='删除')
btn2 = tk.Button(win, text='修改')
btn3 = tk.Button(win, text='增加')
btn4 = tk.Button(win, text='生成邀请函')
lblImg = tk.Label(win)
# 组件布局
lbl.grid(row=0, column=0, columnspan=4,padx=10, pady=10)
lbx.grid(row=1, column=0, rowspan=4)
txt.grid(row=1, column=1)
lblImg.grid(row=2,column=1, rowspan=3)
btn1.grid(row=2, column=2)
btn2.grid(row=3, column=2)
btn3.grid(row=4, column=2)
btn4.grid(row=5, column=0, columnspan=3)
# 事件
lbx.bind('<<ListboxSelect>>',mySelect)
btn1.config(command=myDelete)
btn2.config(command=myUpdate)
btn3.config(command=myAdd)
btn4.config(command=genPics)
# 接受各类事件响应
win.mainloop()
